Bug 1335889 (CVE-2016-4794) - CVE-2016-4794 kernel: Use after free in array_map_alloc
Summary: CVE-2016-4794 kernel: Use after free in array_map_alloc
Status: NEW
Alias: CVE-2016-4794
Product: Security Response
Classification: Other
Component: vulnerability   
(Show other bugs)
Version: unspecified
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard: impact=moderate,public=20160417,repor...
Keywords: Security
Depends On: 1335890 1344568 1344569 1344570 1344571 1344572 1344573 1344574 1344575
Blocks: 1336283
TreeView+ depends on / blocked
 
Reported: 2016-05-13 13:27 UTC by Adam Mariš
Modified: 2019-02-08 15:02 UTC (History)
31 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Use after free vulnerability was found in percpu using previously allocated memory in bpf. First __alloc_percpu_gfp() is called, then the memory is freed with free_percpu() which triggers async pcpu_balance_work and then pcpu_extend_area_map could use a chunk after it has been freed.
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2016:2574 normal SHIPPED_LIVE Important: kernel security, bug fix, and enhancement update 2016-11-03 12:06:10 UTC
Red Hat Product Errata RHSA-2016:2584 normal SHIPPED_LIVE Important: kernel-rt security, bug fix, and enhancement update 2016-11-03 12:08:49 UTC

Description Adam Mariš 2016-05-13 13:27:43 UTC
Use after free vulnerability was found in percpu using previously allocated memory in bpf. First __alloc_percpu_gfp() is called, then the memory is freed with free_percpu() which triggers async pcpu_balance_work and then pcpu_extend_area_map is hitting use-after-free.

CVE request (contains reproducer):
http://seclists.org/oss-sec/2016/q2/332

1: percpu: fix synchronization between chunk->map_extend_work and chunk destruction
( https://www.mail-archive.com/netdev@vger.kernel.org/msg111820.html )

2: percpu: fix synchronization between synchronous map extension and chunk destruction
( https://www.mail-archive.com/netdev@vger.kernel.org/msg111747.html )

Comment 1 Adam Mariš 2016-05-13 13:28:34 UTC
Created kernel tracking bugs for this issue:

Affects: fedora-all [bug 1335890]

Comment 8 Wade Mealing 2016-06-10 05:33:02 UTC
Statement:

This issue does not affect the Linux kernels as shipped with Red Hat Enterprise Linux 4, 5 and 6.

This issue affects the Linux kernels as shipped with Red Hat Enterprise Linux 7 and MRG-2 and may be addressed in a future update.

Comment 12 errata-xmlrpc 2016-11-03 16:33:25 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7

Via RHSA-2016:2574 https://rhn.redhat.com/errata/RHSA-2016-2574.html

Comment 13 errata-xmlrpc 2016-11-03 19:51:31 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7

Via RHSA-2016:2584 https://rhn.redhat.com/errata/RHSA-2016-2584.html

Comment 14 errata-xmlrpc 2016-11-03 21:35:10 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7

Via RHSA-2016:2574 https://rhn.redhat.com/errata/RHSA-2016-2574.html

Comment 15 errata-xmlrpc 2016-11-03 21:50:31 UTC
This issue has been addressed in the following products:

  Red Hat Enterprise Linux 7

Via RHSA-2016:2584 https://rhn.redhat.com/errata/RHSA-2016-2584.html


Note You need to log in before you can comment on or make changes to this bug.